(function ($, Drupal) {
  'use strict';

  Drupal.bpmn_io = {};

  Drupal.behaviors.bpmn_io = {
    attach: function (context, settings) {
      if (Drupal.bpmn_io.modeler === undefined) {
        Drupal.bpmn_io.modeler = window.modeler;
        Drupal.bpmn_io.loader = Drupal.bpmn_io.modeler.get('elementTemplatesLoader');
        Drupal.bpmn_io.loader.setTemplates(settings.bpmn_io.templates);
        Drupal.bpmn_io.open(settings.bpmn_io.bpmn);
        $('#bpmn-io .save-button').click(Drupal.bpmn_io.export);
      }
    }
  };

  Drupal.bpmn_io.export = async function () {
    try {
      let result = await Drupal.bpmn_io.modeler.saveXML({ format: true });
      $.ajax({
        url: '/admin/config/workflow/eca/'  + drupalSettings.bpmn_io.modeler + '/save',
        type: 'POST',
        data: result.xml,
        error: function (e) {
          alert('Something went wrong! See console for details.');
          console.error(e);
        },
        success: function(result) {
          alert('Success!');
        }
      });
    } catch (err) {
      console.error('could not save BPMN 2.0 diagram', err);
    }
  }

  Drupal.bpmn_io.open = async function (bpmnXML) {
    try {
      await Drupal.bpmn_io.modeler.importXML(bpmnXML);
      Drupal.bpmn_io.canvas = Drupal.bpmn_io.modeler.get('canvas');
      Drupal.bpmn_io.overlays = Drupal.bpmn_io.modeler.get('overlays');
      Drupal.bpmn_io.canvas.zoom('fit-viewport');
    }
    catch (err) {
      console.error('something went wrong: ', err);
    }
  }

})(jQuery, Drupal);
