<?php

namespace Drupal\bpmn_io\Controller;

use Drupal\Component\Utility\Random;
use Drupal\Component\Uuid\UuidInterface;
use Drupal\Core\Controller\ControllerBase;
use Drupal\eca\ModelerServices;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Class BpmnIo.
 *
 * @package Drupal\bpmn_io\Controller
 */
class BpmnIo extends ControllerBase {

  /**
   * @var \Drupal\Component\Uuid\UuidInterface
   */
  protected UuidInterface $uuid;

  /**
   * @var \Drupal\eca\ModelerServices
   */
  protected ModelerServices $modelerServices;

  /**
   * BpmnIo constructor.
   *
   * @param \Drupal\Component\Uuid\UuidInterface $uuid
   * @param \Drupal\eca\ModelerServices $modeler_services
   */
  public function __construct(UuidInterface $uuid, ModelerServices $modeler_services) {
    $this->uuid = $uuid;
    $this->modelerServices = $modeler_services;
  }

  /**
   * {@inheritdoc}
   */
  public static function create(ContainerInterface $container): BpmnIo {
    return new static(
      $container->get('uuid'),
      $container->get('eca.service.modeler')
    );
  }

  public function add(): array {
    if ($modeler = $this->modelerServices->getModeler('bpmn_io')) {
      $random = new Random();
      $id = 'Process_' . $random->name(7);
      $emptyBpmn = file_get_contents(drupal_get_path('module', 'bpmn_io') . '/data/empty.bpmn');
      $emptyBpmn = str_replace([
        'SIDPLACEHOLDER1',
        'SIDPLACEHOLDER2',
        'IDPLACEHOLDER'
      ], [
        'sid-' . $this->uuid->generate(),
        'sid-' . $this->uuid->generate(),
        $id,
      ], $emptyBpmn);
      return $modeler->edit(strtolower($id), $emptyBpmn);
    }
    return [];
  }

}
