<?php

namespace Drupal\bpmn_io\Plugin\ECA\Modeler;

use Drupal\Core\StringTranslation\StringTranslationTrait;
use Drupal\eca\Annotation\EcaModeler;
use Drupal\eca\PluginModelerBpmnBase;

/**
 * Plugin implementation of the ECA Modeler.
 *
 * @EcaModeler(
 *   id = "bpmn_io",
 * )
 */
class BpmnIo extends PluginModelerBpmnBase {

  use StringTranslationTrait;

  /**
   * {@inheritdoc}
   */
  public function isEditable(): bool {
    return TRUE;
  }

  /**
   * {@inheritdoc}
   */
  public function edit($id, $bpmn): array {
    return [
      '#markup' => $this->t('Save'),
      '#prefix' => '<div id="bpmn-io"><div class="canvas"></div><div class="property-panel"></div><div class="btn save-button">',
      '#suffix' => '</div></div>',
      '#attached' => [
        'library' => [
          'bpmn_io/ui',
        ],
        'drupalSettings' => [
          'bpmn_io' => [
            'id' => $id,
            'modeler' => 'bpmn_io',
            'bpmn' => $bpmn,
            'templates' => $this->getTemplates(),
          ],
        ],
      ],
    ];
  }

}
